diff --git a/game/client/src/main/java/net/minecraft/client/gui/server/ServerListenerThread.java b/game/client/src/main/java/net/minecraft/client/gui/server/ServerListenerThread.java
new file mode 100644
index 000000000..7010e1a4c
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/gui/server/ServerListenerThread.java
@@ -0,0 +1,131 @@
+package net.minecraft.client.gui.server;
+
+import com.mojang.logging.LogUtils;
+import net.minecraft.client.net.thread.ThreadPingServer;
+import org.jetbrains.annotations.NotNull;
+import org.slf4j.Logger;
+
+import java.io.IOException;
+import java.net.DatagramPacket;
+import java.net.InetAddress;
+import java.net.MulticastSocket;
+import java.util.HashMap;
+import java.util.Map;
+
+public class ServerListenerThread extends Thread{
+    private static final Logger LOGGER = LogUtils.getLogger();
+    public final @NotNull ScreenSelectServer attachedScreen;
+    public final @NotNull ServerManager serverManager;
+    public final @NotNull Map<ServerEntry, ThreadPingServer> pingThreads = new HashMap<>();
+    public boolean keepAlive = true;
+
+    protected MulticastSocket multicastSocket = null;
+    protected byte[] buf = new byte[256];
+
+    public ServerListenerThread(@NotNull ScreenSelectServer attachedScreen) {
+        this.attachedScreen = attachedScreen;
+        this.serverManager = attachedScreen.serverManager;
+    }
+
+    @Override
+    public void run() {
+        boolean multiCastAlive = false;
+        InetAddress group = null;
+        try {
+            multicastSocket = new MulticastSocket(4445);
+            group = InetAddress.getByName("224.0.2.61");
+            multicastSocket.joinGroup(group);
+            multiCastAlive = true;
+        } catch (IOException e) {
+            LOGGER.error("", e);
+        }
+        while (keepAlive) {
+            try {
+                serverManager.idToEntryLock.lock();
+                try {
+                    for (ServerEntry entry : serverManager.idToEntryMap.values()) {
+                        if (entry.dirty && !pingThreads.containsKey(entry)) {
+                            entry.dirty = false;
+                            synchronized (pingThreads) {
+                                ThreadPingServer threadPingServer2 = new ThreadPingServer(this, entry);
+                                pingThreads.put(entry, threadPingServer2);
+                                threadPingServer2.start();
+                            }
+                        }
+                    }
+                } finally {
+                    serverManager.idToEntryLock.unlock();
+                }
+                if (multiCastAlive) {
+                    try {
+                        DatagramPacket packet = new DatagramPacket(buf, buf.length);
+                        multicastSocket.receive(packet);
+                        String received = new String(packet.getData(), 0, packet.getLength());
+                        if ("end".equals(received)) {
+                            multiCastAlive = false;
+                        } else {
+                            receivedLocalServer(packet, received);
+                        }
+                    } catch (IOException e) {
+                        LOGGER.error("", e);
+                    }
+                }
+                Thread.sleep(1000);
+            } catch (InterruptedException e) {
+                LOGGER.error("", e);
+            }
+        }
+        try {
+            if (group != null) multicastSocket.leaveGroup(group);
+        } catch (IOException e) {
+            LOGGER.error("", e);
+        }
+        if (multicastSocket != null) multicastSocket.close();
+    }
+
+    public void receivedLocalServer(DatagramPacket packet, String localServerBroadcast) {
+        String motd = null;
+        if (localServerBroadcast.contains("[MOTD]")) {
+            int start = localServerBroadcast.indexOf("[MOTD]");
+            int end = localServerBroadcast.indexOf("[/MOTD]");
+            if (start != -1 && end != -1) {
+                motd = localServerBroadcast.substring(start + "[MOTD]".length(), end);
+            }
+        }
+        String port = null;
+        if (localServerBroadcast.contains("[AD]")) {
+            int start = localServerBroadcast.indexOf("[AD]");
+            int end = localServerBroadcast.indexOf("[/AD]");
+            if (start != -1 && end != -1) {
+                port = localServerBroadcast.substring(start + "[AD]".length(), end);
+            }
+        }
+        String name = null;
+        if (localServerBroadcast.contains("[NAME]")) {
+            int start = localServerBroadcast.indexOf("[NAME]");
+            int end = localServerBroadcast.indexOf("[/NAME]");
+            if (start != -1 && end != -1) {
+                name = localServerBroadcast.substring(start + "[NAME]".length(), end);
+            }
+        }
+        String ip = packet.getAddress().getHostAddress();
+        if (ip != null && port != null) {
+            int portInt;
+            try {
+                portInt = Integer.parseInt(port);
+            } catch (Exception e) {
+                return;
+            }
+            serverManager.onLocalScanned(ip, portInt, motd, name);
+        }
+    }
+
+    public void handleIncomingServerInfo(ServerEntry server) {
+        synchronized (pingThreads) {
+            ThreadPingServer pingServer = pingThreads.remove(server);
+            if (pingServer != null) {
+                pingServer.interrupt();
+            }
+        }
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/gui/server/ServerManager.java b/game/client/src/main/java/net/minecraft/client/gui/server/ServerManager.java
new file mode 100644
index 000000000..e4a81f47e
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/gui/server/ServerManager.java
@@ -0,0 +1,247 @@
+package net.minecraft.client.gui.server;
+
+import com.mojang.logging.LogUtils;
+import com.mojang.nbt.NbtIo;
+import com.mojang.nbt.tags.CompoundTag;
+import com.mojang.nbt.tags.ListTag;
+import com.mojang.nbt.tags.LongTag;
+import com.mojang.nbt.tags.StringTag;
+import com.mojang.nbt.tags.Tag;
+import net.minecraft.core.Global;
+import net.minecraft.core.net.ServerAddress;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+import org.slf4j.Logger;
+
+import java.io.File;
+import java.io.IOException;
+import java.nio.file.Files;
+import java.util.ArrayList;
+import java.util.Collection;
+import java.util.HashMap;
+import java.util.HashSet;
+import java.util.List;
+import java.util.Map;
+import java.util.Set;
+import java.util.UUID;
+import java.util.concurrent.locks.Lock;
+import java.util.concurrent.locks.ReentrantLock;
+
+public class ServerManager {
+    private static final Logger LOGGER = LogUtils.getLogger();
+    public Lock idToEntryLock = new ReentrantLock();
+    public final @NotNull Map<UUID, ServerEntry> idToEntryMap = new HashMap<>();
+
+
+    private final @NotNull Map<UUID, ServerEntry> favoritesMap = new HashMap<>();
+    private final @NotNull List<ServerEntry> favorites = new ArrayList<>();
+    private final @NotNull Map<UUID, ServerEntry> internetMap = new HashMap<>();
+    private final @NotNull List<ServerEntry> internet = new ArrayList<>();
+    private final @NotNull Map<UUID, ServerEntry> historyMap = new HashMap<>();
+    private final @NotNull List<ServerEntry> history = new ArrayList<>();
+    private final @NotNull Map<UUID, ServerEntry> lanMap = new HashMap<>();
+    private final @NotNull Map<ServerAddress, ServerEntry> lanAddressMap = new HashMap<>();
+    private final @NotNull List<ServerEntry> lan = new ArrayList<>();
+
+    public static @NotNull ServerManager getServerManager(@NotNull ScreenSelectServer attachedScreen) {
+        File file = new File(Global.accessor.getMinecraftDir() + "/servers_new.dat");
+        try {
+            return new ServerManager(attachedScreen, NbtIo.readCompressed(Files.newInputStream(file.toPath())));
+        } catch (IOException e) {
+            LOGGER.error("", e);
+            return new ServerManager(attachedScreen, new CompoundTag());
+        }
+    }
+
+    public static void saveServerManager(@NotNull ServerManager savedServerData) {
+        File file = new File(Global.accessor.getMinecraftDir() + "/servers_new.dat");
+        if (!file.exists()) {
+            try {
+                //noinspection ResultOfMethodCallIgnored
+                file.createNewFile();
+            } catch (IOException e) {
+                LOGGER.error("", e);
+                return;
+            }
+        }
+
+        try {
+            NbtIo.writeCompressed(savedServerData.toTag(), Files.newOutputStream(file.toPath()));
+        } catch (IOException e) {
+            LOGGER.error("", e);
+        }
+    }
+
+    private final @NotNull ScreenSelectServer attachedScreen;
+    private ServerManager(@NotNull ScreenSelectServer attachedScreen, @NotNull CompoundTag compoundTag) {
+        this.attachedScreen = attachedScreen;
+
+        CompoundTag entries = compoundTag.getCompound("ServerData");
+        for (Map.Entry<String, Tag<?>> e : entries.getValue().entrySet()) {
+            UUID uuid = UUID.fromString(e.getKey());
+            CompoundTag entryTag = (CompoundTag) e.getValue();
+            ServerEntry entry = new ServerEntry(uuid, entryTag.getString("Address"));
+            entry.overrideName = entryTag.getStringOrDefault("OverrideName", null);
+            entry.baseName = entryTag.getStringOrDefault("BaseName", null);
+            entry.showIp = entryTag.getBooleanOrDefault("ShowIp", false);
+            entry.dirty = true;
+            entry.requestIcon = true;
+            addEntry(entry);
+        }
+        ListTag favorites = compoundTag.getList("Favorites");
+        for (Tag<?> tag : favorites) {
+            StringTag entryTag = (StringTag) tag;
+            UUID uuid = UUID.fromString(entryTag.getValue());
+            if (this.idToEntryMap.containsKey(uuid)) {
+                ServerEntry entry = this.idToEntryMap.get(uuid);
+                addFavorite(entry);
+            }
+        }
+        CompoundTag h = compoundTag.getCompound("History");
+        for (Map.Entry<String, Tag<?>> e : h.getValue().entrySet()) {
+            UUID uuid = UUID.fromString(e.getKey());
+            if (this.idToEntryMap.containsKey(uuid)) {
+                ServerEntry entry = this.idToEntryMap.get(uuid);
+                entry.lastPlayedTime = ((LongTag)e.getValue()).getValue();
+                if (!this.historyMap.containsKey(entry.uuid)) {
+                    this.historyMap.put(entry.uuid, entry);
+                    this.history.add(entry);
+                }
+            }
+        }
+        history.sort((o1, o2) -> Long.compare(o2.lastPlayedTime, o1.lastPlayedTime));
+
+    }
+
+    private @NotNull CompoundTag toTag() {
+        CompoundTag tag = new CompoundTag();
+
+        Set<ServerEntry> entriesToSave = new HashSet<>();
+
+        ListTag favorites = new ListTag();
+        for (ServerEntry entry : this.favorites) {
+            entriesToSave.add(entry);
+            favorites.addTag(new StringTag(entry.uuid.toString()));
+        }
+
+        CompoundTag history = new CompoundTag();
+        for (ServerEntry entry : this.history) {
+            entriesToSave.add(entry);
+            history.put(entry.uuid.toString(), new LongTag(entry.lastPlayedTime));
+        }
+
+        CompoundTag serverData = new CompoundTag();
+        for (ServerEntry entry : entriesToSave) {
+            CompoundTag eTag = new CompoundTag();
+            eTag.putString("Address", entry.address);
+            if (entry.overrideName != null) eTag.putString("OverrideName", entry.overrideName);
+            if (entry.baseName != null) eTag.putString("BaseName", entry.baseName);
+            if (entry.showIp) eTag.putBoolean("ShowIp", true);
+            serverData.put(entry.uuid.toString(), eTag);
+        }
+
+        tag.put("ServerData", serverData);
+        tag.put("Favorites", favorites);
+        tag.put("History", history);
+
+
+        return tag;
+    }
+
+    public void addEntry(@NotNull ServerEntry entry) {
+        idToEntryLock.lock();
+        try {
+            idToEntryMap.put(entry.uuid, entry);
+        } finally {
+            idToEntryLock.unlock();
+        }
+    }
+
+    public void addFavorite(@NotNull ServerEntry entry) {
+        addEntry(entry);
+        if (!favoritesMap.containsKey(entry.uuid)) {
+            favoritesMap.put(entry.uuid, entry);
+            favorites.add(entry);
+        }
+    }
+
+    public void onJoined(@NotNull ServerEntry entry) {
+        addEntry(entry);
+        entry.lastPlayedTime = System.currentTimeMillis();
+        if (!historyMap.containsKey(entry.uuid)) {
+            historyMap.put(entry.uuid, entry);
+            history.add(entry);
+        }
+        history.sort((o1, o2) -> Long.compare(o2.lastPlayedTime, o1.lastPlayedTime));
+    }
+
+    public void onLocalScanned(@NotNull String ip, int port, @Nullable String motd, @Nullable String name) {
+        ServerAddress address = ServerAddress.resolveServerIP(String.format("%s:%s", ip, port));
+        if (!lanAddressMap.containsKey(address)) {
+            ServerEntry entry = new ServerEntry(UUID.randomUUID(), String.format("%s:%s", ip, port));
+            if (name == null || name.isBlank()) {
+                entry.baseName = "Lan Server";
+            } else {
+                entry.baseName = name;
+            }
+            entry.motd = motd;
+            entry.showIp = true;
+            entry.addressResolved = address;
+            entry.dirty = true;
+            entry.requestIcon = true;
+            addEntry(entry);
+            lan.add(entry);
+            lanMap.put(entry.uuid, entry);
+            lanAddressMap.put(address, entry);
+            attachedScreen.needToRefreshPages = true;
+        }
+    }
+
+    public void removeFavorite(@NotNull ServerEntry entry) {
+        favorites.remove(entry);
+        favoritesMap.remove(entry.uuid);
+        checkValid(entry);
+    }
+
+    public void removeHistory(@NotNull ServerEntry entry) {
+        history.remove(entry);
+        historyMap.remove(entry.uuid);
+        checkValid(entry);
+    }
+
+    public void checkValid(@NotNull ServerEntry entry) {
+        if (
+            !favoritesMap.containsKey(entry.uuid) &&
+            !internetMap.containsKey(entry.uuid) &&
+            !historyMap.containsKey(entry.uuid) &&
+            !lanMap.containsKey(entry.uuid)
+        ) {
+            idToEntryMap.remove(entry.uuid);
+        }
+    }
+
+    public void freeResources() {
+        idToEntryLock.lock();
+        try {
+            idToEntryMap.forEach((uuid, entry) -> entry.free());
+        } finally {
+            idToEntryLock.unlock();
+        }
+    }
+
+    public @NotNull Collection<ServerEntry> getFavorites() {
+        return favorites;
+    }
+
+    public @NotNull Collection<ServerEntry> getInternet() {
+        return internet;
+    }
+
+    public @NotNull Collection<ServerEntry> getHistory() {
+        return history;
+    }
+
+    public @NotNull Collection<ServerEntry> getLan() {
+        return lan;
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/gui/server/SeverDirectConnectComponent.java b/game/client/src/main/java/net/minecraft/client/gui/server/SeverDirectConnectComponent.java
new file mode 100644
index 000000000..99ea59d47
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/gui/server/SeverDirectConnectComponent.java
@@ -0,0 +1,103 @@
+package net.minecraft.client.gui.server;
+
+import net.minecraft.client.gui.ButtonElement;
+import net.minecraft.client.gui.TextFieldElement;
+import net.minecraft.client.gui.paged.PageComponent;
+import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.core.lang.I18n;
+import net.minecraft.core.net.ServerAddress;
+import org.jetbrains.annotations.NotNull;
+import org.lwjgl.input.Keyboard;
+
+import java.util.Map;
+import java.util.UUID;
+
+public class SeverDirectConnectComponent implements PageComponent {
+    public final ScreenSelectServer attachedScreen;
+    public TextFieldElement ipField;
+    public ButtonElement connectButton;
+    public SeverDirectConnectComponent(@NotNull ScreenSelectServer attachedScreen) {
+        this.attachedScreen = attachedScreen;
+        this.ipField = new TextFieldElement(attachedScreen, attachedScreen.fontRenderer, 0, 0, 150, 18, "", "");
+        this.connectButton = new ButtonElement(0, 0, 0, 150, 20, I18n.getInstance().translateKey("gui.select_server.popup.direct.button.connect"));
+    }
+    @Override
+    public int getHeight() {
+        return attachedScreen.height / 2;
+    }
+
+    @Override
+    public void render(int x, int y, int width, int relativeMouseX, int relativeMouseY) {
+        int _x = x + width / 2 - this.ipField.width / 2;
+        int _y = attachedScreen.height / 2 - 40;
+
+        attachedScreen.mc.font.render(Tessellator.instance, I18n.getInstance().translateKey("gui.select_server.popup.add.prompt.ip"), _x, _y).setShadow().call();
+        this.ipField.xPosition = _x;
+        this.ipField.yPosition = attachedScreen.mc.font.getLastEndingY() + 1;
+
+        this.ipField.drawTextBox();
+        this.ipField.updateCursor(attachedScreen.mc, x + relativeMouseX, y + relativeMouseY);
+
+        this.connectButton.xPosition = _x;
+        this.connectButton.yPosition = this.ipField.yPosition + this.ipField.height + 2;
+        this.connectButton.drawButton(attachedScreen.mc, x + relativeMouseX, y + relativeMouseY);
+    }
+
+    @Override
+    public void tick() {
+        this.ipField.updateCursorCounter();
+    }
+
+    @Override
+    public void onMouseClick(int mouseButton, int x, int y, int width, int relativeMouseX, int relativeMouseY) {
+        this.ipField.mouseClicked(x + relativeMouseX, y + relativeMouseY, 0);
+        if (this.connectButton.isHovered(x + relativeMouseX, y + relativeMouseY)) {
+            connect();
+        }
+    }
+
+    @Override
+    public void onMouseMove(int x, int y, int width, int relativeMouseX, int relativeMouseY) {
+
+    }
+
+    @Override
+    public void onMouseRelease(int mouseButton, int x, int y, int width, int relativeMouseX, int relativeMouseY) {
+
+    }
+
+    @Override
+    public void onKeyPress(int keyCode, char character) {
+        if (this.ipField.isFocused && keyCode == Keyboard.KEY_RETURN) {
+            connect();
+        } else if (this.ipField.isFocused && keyCode != Keyboard.KEY_ESCAPE) {
+            this.ipField.textboxKeyTyped(character, keyCode);
+        } else if (keyCode == Keyboard.KEY_ESCAPE) {
+            this.ipField.setFocused(false);
+        }
+    }
+
+    private void connect() {
+        String ip = this.ipField.getText();
+        ServerAddress address = ServerAddress.resolveServerIP(ip);
+        if (address != null) {
+            attachedScreen.addressToJoin = address;
+//            attachedScreen.serverManager.idToEntryLock.lock();
+//            try {
+//                for (Map.Entry<UUID, ServerEntry> entry : attachedScreen.serverManager.idToEntryMap.entrySet()) {
+//                    ServerEntry serverEntry = entry.getValue();
+//                    if (serverEntry.getServerAddress().equals(address)) {
+//                        attachedScreen.serverManager.onJoined(serverEntry);
+//                    }
+//                }
+//            } finally {
+//                attachedScreen.serverManager.idToEntryLock.unlock();
+//            }
+        }
+    }
+
+    @Override
+    public boolean matchesSearchTerm(String term) {
+        return false;
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/net/handler/PingPacketHandler.java b/game/client/src/main/java/net/minecraft/client/net/handler/PingPacketHandler.java
index 118b357b6..f5d71fcd5 100644
--- a/game/client/src/main/java/net/minecraft/client/net/handler/PingPacketHandler.java
+++ b/game/client/src/main/java/net/minecraft/client/net/handler/PingPacketHandler.java
@@ -1,33 +1,42 @@
 package net.minecraft.client.net.handler;
 
-import net.minecraft.client.gui.ScreenSelectServer;
+import com.mojang.logging.LogUtils;
+import net.minecraft.client.gui.server.ServerEntry;
+import net.minecraft.client.gui.server.ServerListenerThread;
 import net.minecraft.core.net.NetworkManager;
 import net.minecraft.core.net.ServerAddress;
-import net.minecraft.core.net.ServerData;
 import net.minecraft.core.net.handler.PacketHandler;
 import net.minecraft.core.net.packet.PacketDisconnect;
 import net.minecraft.core.net.packet.Packet;
-import net.minecraft.core.net.packet.PacketPingHandshake;
+import net.minecraft.core.net.packet.PacketServerIcon;
+import org.slf4j.Logger;
 
+import javax.imageio.ImageIO;
+import java.io.ByteArrayInputStream;
 import java.io.IOException;
 import java.net.InetAddress;
 import java.net.Socket;
+import java.util.Arrays;
 
 public class PingPacketHandler
     extends PacketHandler
 {
-    private boolean disconnected = false;
-    private final ScreenSelectServer screen;
+    private static final Logger LOGGER = LogUtils.getLogger();
+    public boolean disconnected = false;
+    private final ServerListenerThread listener;
     private final NetworkManager netManager;
-    private final ServerData server;
+    private final ServerEntry server;
+    private final long startTime;
 
-    public PingPacketHandler(ScreenSelectServer screen, ServerData server)
+    public PingPacketHandler(ServerListenerThread listener, ServerEntry server)
         throws IOException {
-        this.screen = screen;
+        this.listener = listener;
         this.server = server;
         ServerAddress address = server.getServerAddress();
         Socket socket = new Socket(InetAddress.getByName(address.getIP()), address.getPort());
         netManager = new NetworkManager(socket, "Ping", this, 100, true);
+        startTime = System.currentTimeMillis();
+        server.isUp = false;
     }
 
     public void processReadPackets()
@@ -60,17 +69,36 @@ public class PingPacketHandler
             server.protocolVersion = parseIntWithDefault(serverInfo[1], -1);
             server.version = serverInfo[2];
             server.motd = serverInfo[3];
-            server.currentPlayers = parseIntWithDefault(serverInfo[4], -1);
-            server.maxPlayers = parseIntWithDefault(serverInfo[5], -1);
-            server.latency = System.currentTimeMillis() - PacketPingHandshake.startTime;
+            server.playerCount = parseIntWithDefault(serverInfo[4], -1);
+            server.playerCap = parseIntWithDefault(serverInfo[5], -1);
+            server.ping = System.currentTimeMillis() - startTime;
 
-            screen.handleIncomingServerInfo(server);
+            if (serverInfo.length >= 7) {
+                server.baseName = serverInfo[6];
+            }
+            server.players.clear();
+            if (serverInfo.length >= 8) {
+                String playersString = serverInfo[7];
+                String[] players = playersString.split(",");
+                server.players.addAll(Arrays.asList(players));
+            }
+
+            listener.handleIncomingServerInfo(server);
 
             netManager.networkShutdown("disconnect.kicked", new Object[0]);
             disconnected = true;
         }
     }
 
+    @Override
+    public void handleServerIconPacket(PacketServerIcon packetServerIcon) {
+        try {
+            server.queuedIcon = ImageIO.read(new ByteArrayInputStream(packetServerIcon.image));
+        } catch (IOException e) {
+            LOGGER.error("", e);
+        }
+    }
+
     private int parseIntWithDefault(String s, int i) {
         try {
             return Integer.parseInt(s.trim());
diff --git a/game/client/src/main/java/net/minecraft/client/net/thread/ThreadPingServer.java b/game/client/src/main/java/net/minecraft/client/net/thread/ThreadPingServer.java
index 9d14230d7..50c89f30b 100644
--- a/game/client/src/main/java/net/minecraft/client/net/thread/ThreadPingServer.java
+++ b/game/client/src/main/java/net/minecraft/client/net/thread/ThreadPingServer.java
@@ -1,47 +1,29 @@
 package net.minecraft.client.net.thread;
 
-import net.minecraft.client.gui.ScreenSelectServer;
+import net.minecraft.client.gui.server.ServerEntry;
+import net.minecraft.client.gui.server.ServerListenerThread;
 import net.minecraft.client.net.handler.PingPacketHandler;
 import net.minecraft.core.Global;
 import net.minecraft.core.net.ServerAddress;
-import net.minecraft.core.net.ServerData;
-import net.minecraft.core.net.handler.PacketHandler;
 import net.minecraft.core.net.packet.PacketPingHandshake;
 
 public class ThreadPingServer
     extends Thread {
 
-    private final ScreenSelectServer screen;
-    private final ServerData server;
-    private boolean done = false;
-    private PingPacketHandler netHandler = null;
+    private final ServerListenerThread listenerThread;
+    private final ServerEntry server;
 
-    public ThreadPingServer(ScreenSelectServer screen, ServerData server) {
-        this.screen = screen;
+    public ThreadPingServer(ServerListenerThread listenerThread, ServerEntry server) {
+        this.listenerThread = listenerThread;
         this.server = server;
-//        Turns out getting the real address like this is horribly horribly slow, taking me sometime 40 seconds to process all of these set names
-//        ServerAddress address = server.getServerAddress();
-//        this.setName("ThreadPingServer - " + address.getIP() + ":" + address.getPort());
 
         this.setName("ThreadPingServer - " + server.address);
     }
 
-    public ServerData getServer() {
+    public ServerEntry getServer() {
         return server;
     }
 
-    public boolean isDone() {
-        return done;
-    }
-
-    public void tickNetClientHandler() {
-        if (netHandler != null && isDone()) netHandler.processReadPackets();
-    }
-
-    public PacketHandler getNetHandler() {
-        return netHandler;
-    }
-
     @Override
     public void run() {
         ServerAddress address = this.server.getServerAddress();
@@ -49,11 +31,18 @@ public class ThreadPingServer
         int port = address.getPort();
 
         try {
-            netHandler = new PingPacketHandler(screen, server);
-            netHandler.addToSendQueue(new PacketPingHandshake(0x01, 0xFA, "BTAPingHost", Global.MP_PROTOCOL_VERSION, hostName, port));
+            PingPacketHandler netHandler = new PingPacketHandler(listenerThread, server);
+            if (server.requestIcon) {
+                netHandler.addToSendQueue(new PacketPingHandshake(0x03, 0xFA, "BTAPingHost", Global.MP_PROTOCOL_VERSION, hostName, port));
+                server.requestIcon = false;
+            } else {
+                netHandler.addToSendQueue(new PacketPingHandshake(0x02, 0xFA, "BTAPingHost", Global.MP_PROTOCOL_VERSION, hostName, port));
+            }
+            while (!netHandler.disconnected) {
+                netHandler.processReadPackets();
+                Thread.sleep(1);
+            }
         } catch (Exception ignored) {
-        } finally {
-            done = true;
         }
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/WorldRenderer.java b/game/client/src/main/java/net/minecraft/client/render/WorldRenderer.java
index 3b118fc33..be5894d06 100644
--- a/game/client/src/main/java/net/minecraft/client/render/WorldRenderer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/WorldRenderer.java
@@ -648,7 +648,7 @@ public class WorldRenderer
         mc.renderer.beginRenderWorld(partialTicks);
         glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
         glEnable(GL_CULL_FACE);
-        setupCameraTransform(partialTicks);
+        setupCameraTransform((mc.activeCamera instanceof EntityCamera && ((EntityCamera) mc.activeCamera).mob.isRemoved()) ? 1f : partialTicks);
         Frustum.getFrustum();
         Debug.change("sky");
         if((mc.gameSettings.renderDistance.value > 4) /* Used to use Renderdistance rendersky! */ && !(mc.currentScreen instanceof ScreenModelViewer))
@@ -779,7 +779,7 @@ public class WorldRenderer
 
         Debug.change("misc");
         fogManager.setupFog(1, farPlaneDistance, partialTicks);
-        renderHand(partialTicks);
+        renderHand((mc.activeCamera instanceof EntityCamera && ((EntityCamera) mc.activeCamera).mob.isRemoved()) ? 1f : partialTicks);
         
         glColorMask(true, true, true, true);
         Debug.pop();
diff --git a/game/client/src/main/java/net/minecraft/client/render/camera/EntityCamera.java b/game/client/src/main/java/net/minecraft/client/render/camera/EntityCamera.java
index 744028fb8..c9c99fe9a 100644
--- a/game/client/src/main/java/net/minecraft/client/render/camera/EntityCamera.java
+++ b/game/client/src/main/java/net/minecraft/client/render/camera/EntityCamera.java
@@ -40,7 +40,7 @@ public abstract class EntityCamera
     @Override
     public double getX(float partialTick)
     {
-        if (partialTick == 1f)
+        if (partialTick == 1f || mob.isRemoved())
         {
             return mob.x;
         }
@@ -53,7 +53,7 @@ public abstract class EntityCamera
     @Override
     public double getY(float partialTick)
     {
-        if (partialTick == 1f)
+        if (partialTick == 1f || mob.isRemoved())
         {
             return mob.y + mob.getHeadHeight();
         }
@@ -67,7 +67,7 @@ public abstract class EntityCamera
     @Override
     public double getZ(float partialTick)
     {
-        if (partialTick == 1f)
+        if (partialTick == 1f || mob.isRemoved())
         {
             return mob.z;
         }
@@ -81,7 +81,7 @@ public abstract class EntityCamera
     @Override
     public double getXRot(float partialTick)
     {
-        if (partialTick == 1f)
+        if (partialTick == 1f || mob.isRemoved())
         {
             return mob.xRot;
         }
@@ -95,7 +95,7 @@ public abstract class EntityCamera
     @Override
     public double getYRot(float partialTick)
     {
-        if (partialTick == 1f)
+        if (partialTick == 1f || mob.isRemoved())
         {
             return mob.yRot;
         }
diff --git a/game/client/src/main/java/net/minecraft/client/render/camera/EntityCameraSleeping.java b/game/client/src/main/java/net/minecraft/client/render/camera/EntityCameraSleeping.java
index a9524a5cb..ebea638d5 100644
--- a/game/client/src/main/java/net/minecraft/client/render/camera/EntityCameraSleeping.java
+++ b/game/client/src/main/java/net/minecraft/client/render/camera/EntityCameraSleeping.java
@@ -94,7 +94,7 @@ public class EntityCameraSleeping
     @Override
     public double getX(float partialTick)
     {
-        if (partialTick == 1f)
+        if (partialTick == 1f || mob.isRemoved())
         {
             return x;
         }
@@ -107,7 +107,7 @@ public class EntityCameraSleeping
     @Override
     public double getY(float partialTick)
     {
-        if (partialTick == 1f)
+        if (partialTick == 1f || mob.isRemoved())
         {
             return y;
         }
@@ -120,7 +120,7 @@ public class EntityCameraSleeping
     @Override
     public double getZ(float partialTick)
     {
-        if (partialTick == 1f)
+        if (partialTick == 1f || mob.isRemoved())
         {
             return z;
         }
@@ -133,7 +133,7 @@ public class EntityCameraSleeping
     @Override
     public double getXRot(float partialTick)
     {
-        if (partialTick == 1f)
+        if (partialTick == 1f || mob.isRemoved())
         {
             return xRot;
         }
@@ -146,7 +146,7 @@ public class EntityCameraSleeping
     @Override
     public double getYRot(float partialTick)
     {
-        if (partialTick == 1f)
+        if (partialTick == 1f || mob.isRemoved())
         {
             return yRot;
         }
